// Sun Aug 18 08:25:55 MET DST 1996

// toDo:	- remove startupicon
//			- optimize TextStream handling (checkin at the beginning of long texts)
//			- Captalization check: prev. char == '.' and lower spaced exists->


#import "SpellDelegate.h"

//#define DEBUG


@implementation SpellDelegate

const char *simClusters[]=
{"sqy>",	//a
 "vngh",	//b
 "xvdf",	//c
 "sfercx",	//d
 "wrsd34",	//e
 "dgrvc",	//f
 "vbfhtz",	//g
 "bngjzu",	//h
 "uojkl",	//i
 "nmhkui",	//j
 "jlm,io",	//k
 "kop,.",	//l
 ",njkl",	//m
 "bmhj",	//n
 "pilk90",	//o
 "ol0",	//p
 "asw12",	//q
 "etdf45",	//r
 "adyxwe",	//s
 "rz56fg",	//t
 "zi78hj",	//u
 "cbfg",	//v
 "qe23sa",	//w
 "ycsd",	//x
 "<>xas",	//y
 "tugh67",	//z
};

- initBTree
{	char	path[MAXPATHLEN+1];

	if([[NXBundle mainBundle] getPath:path forResource:"Words" ofType:"dict"])
	{	NXStream	*localStream=NXMapFile(path,NX_READONLY);
		const char	*streambuf,*ptr;
		int			 len,maxlen;

		sBtree=[[IXBTree alloc] initInStore:[[IXStore alloc] init]];
		[sBtree setComparisonFormat:"*"];
		sCursor=[[IXBTreeCursor alloc] initWithBTree:sBtree];

		NXGetMemoryBuffer(localStream,&streambuf,&len,&maxlen);
		for(ptr=streambuf;ptr<len+streambuf;)
		{	char *optr;
			optr=strchr(ptr,' ');
			if(!optr) break;
			[sCursor setKey:ptr andLength:optr-ptr];
			[sCursor writeValue:"" andLength:1];
			ptr+=(optr-ptr+1);
		} NXClose(localStream);

	} else	// dump file
	{	NXStream *stream = NXOpenMemory(NULL,0,NX_READWRITE);
		MiscString *tmpStr=[[MiscString alloc] initString:path];
		if (stream)
		{	if([sCursor setFirst])
			{	const char *key;
				int			len;
				do
				{	[sCursor getKey:&key andLength:&len];
					NXWrite(stream,key,len);
					NXPutc(stream,' ');
				} while([sCursor setNext]);
			} [tmpStr cat:"/Words.dict"];
			// [tmpStr setStringValue:"Words1.dict"];
			NXSaveToFile(stream,[tmpStr stringValueAndFree]);
			NXCloseMemory(stream, NX_FREEBUFFER);
		}
	}
	if([[NXBundle mainBundle] getPath:path forResource:"CommonErrors" ofType:"dict"])
	{	NXStream	*localStream=NXMapFile(path,NX_READONLY);
		const char	*streambuf,*ptr;
		int			 len,maxlen;

		eBtree=[[IXBTree alloc] initInStore:[[IXStore alloc] init]];
		[eBtree setComparisonFormat:"*"];
		eCursor=[[IXBTreeCursor alloc] initWithBTree:eBtree];

		NXGetMemoryBuffer(localStream,&streambuf,&len,&maxlen);
		for(ptr=streambuf;ptr<len+streambuf;)
		{	char *optr;
			optr=strchr(ptr,' ');
			if(!optr) break;
			[eCursor setKey:ptr andLength:optr-ptr];
			ptr+=optr-ptr+1;optr=strchr(ptr,' ');
			[eCursor writeValue:ptr andLength:optr-ptr];
			ptr+=optr-ptr+1;
		} NXClose(localStream);
	} return self;
}


- init
{	self=[super init];
	[self initBTree];
	return self;
}

-(BOOL) wordInDir:(const char*) word
{	if(strlen(word) == 1) return YES;
	if([sCursor setKey:word andLength:strlen(word)]) return YES;
	return NO;
}


-(void) spellServer:(NXSpellServer *)sender 
	  didForgetWord:(const char *)word 
		 inLanguage:(const char *)language
{
}
-(void) spellServer:(NXSpellServer *)sender 
	   didLearnWord:(const char *)word 
		 inLanguage:(const char *)language
{
}

#define ReadChunkSize 64000
-(MiscString *) stringForStream:(id <NXReadOnlyTextStream>)textStream start:(int) start
{	MiscString *newStr=[[MiscString alloc] init];
	char		*tmp=malloc(ReadChunkSize+1);
	int			charsRead;

	[textStream seekToCharacterAt:start relativeTo:NX_StreamStart];

	do
	{	charsRead=[textStream readCharacters:tmp count:ReadChunkSize];
		[newStr cat:tmp n:charsRead];
	} while(charsRead == ReadChunkSize);
	free(tmp);
	return newStr;
}

-(BOOL) spellServer:(NXSpellServer *)sender 
	findMisspelledWord:(int *)start 
				length:(int *)length 
			inLanguage:(const char *)language 
		  inTextStream:(id <NXReadOnlyTextStream>)textStream 
			startingAt:(int)startPosition 
			 wordCount:(int *)number 
			 countOnly:(BOOL)countOnly
{	BOOL	erg=NO;
	MiscString *newStr=[self stringForStream:textStream start:startPosition];

	if(countOnly)	*number=[newStr numWords];
	else 	// actual checking starts here
	{	int i,removed=0;
		MiscString *currWord;
		BOOL	exit=NO;
		if(startPosition && !NXIsSpace([newStr charAt:0]))		// skip first word (which may be incomplete)
		{	[newStr wordStart:start andLen:length ofNum:1];
			[newStr removeFrom:0 to:removed=(*start)-1];
			removed++;
		}
		for(i=0;!exit && (currWord=[newStr wordOfNum:i]);i++)
		{	if(![self wordInDir:[currWord stringValue]])
			{	if(![sender isInUserDictionary:[currWord stringValue] caseSensitive:YES])
				{	exit=erg=YES; matched++;
					*number=MAX(i-1,0);
					[newStr wordStart:start andLen:length ofNum:i];
					(*start)+=startPosition+removed;
				}
			} [currWord free];
		}
	} [newStr free];
	if(!erg) mismatched++;
	return erg;
}
-(const char*) suggsetionStrFor:(MiscString *)suggStr server:(NXSpellServer *)sender
{	const char *key;
	int			len;
	static MiscString *retStr;
	if(!retStr) retStr=[[MiscString alloc] init];

	if([sCursor setKey:[suggStr stringValue] andLength:strlen([suggStr stringValue])])
	{	if([sCursor getKey:&key andLength:&len])
		{	[retStr setBytes:key n:len];
			return [retStr stringValue];
		}
	}
	if([sender isInUserDictionary:[suggStr stringValue] caseSensitive:YES])
		return [suggStr stringValue];
	return 0L;
}

-(void) spellServer:(NXSpellServer *)sender 
		suggestGuessesForWord:(const char *)word 
				   inLanguage:(const char *)language
{	MiscString *wordStr=[[MiscString alloc] initString:word];
	char	   *tmpSPtr;

	if([eCursor setKey:word andLength:strlen(word)])
	{	const char *tmpPtr=0;
		int			cnt;
		if(cnt=[eCursor readValue:&tmpPtr])
		{	static MiscString *retStr;
			if(!retStr) retStr=[[MiscString alloc] init];
			[retStr setBytes:tmpPtr n:cnt];
			free((void*)tmpPtr);
			[sender addGuess:[retStr stringValue]];
		}
	} else
	{	MiscString *tmpStr;
		const char *tmpPtr;
		int i;

		for(i=0;i< [wordStr length];i++)	// first lets check if the user typed one faulty char at plus
		{	tmpStr=[wordStr copy];
			[tmpStr removeFrom:i length:1];
			if(tmpPtr=[self suggsetionStrFor:tmpStr server:sender])	[sender addGuess:tmpPtr];
			[tmpStr free];
		}

		for(i=0;i< [wordStr length];i++)	// now lets try if the user accidentally swapped two chars
		{	MiscString *swapString=[wordStr midFrom:i length:2];
			tmpStr=[wordStr copy];
			[swapString reverse];
			[tmpStr removeFrom:i length:2];[tmpStr insertString:swapString at:i];
			if(tmpPtr=[self suggsetionStrFor:tmpStr server:sender])	[sender addGuess:tmpPtr];
			[tmpStr free];[swapString free];
		}

		tmpStr=[wordStr copy];			// capitalisation problem?
		[tmpStr toLower];
		if(tmpPtr=[self suggsetionStrFor:tmpStr server:sender])	[sender addGuess:tmpPtr];
		[tmpStr capitalizeEachWord];
		if(tmpPtr=[self suggsetionStrFor:tmpStr server:sender])	[sender addGuess:tmpPtr];
		[tmpStr free];

		tmpStr=[wordStr copy];			// typical german problem?
		[tmpStr collapseGermanUmlaut];
		if(tmpPtr=[self suggsetionStrFor:tmpStr server:sender])	[sender addGuess:tmpPtr];
		[tmpStr free];

		tmpStr=[wordStr copy];			// typical german problem?
		[tmpStr replaceEveryOccurrenceOf:"ph" withChar:'f'];
		if(tmpPtr=[self suggsetionStrFor:tmpStr server:sender])	[sender addGuess:tmpPtr];
		[tmpStr free];

		tmpStr=[wordStr copy];			// typical german problem?
		[tmpStr replaceEveryOccurrenceOfChar:'f' with:"ph"];
		if(tmpPtr=[self suggsetionStrFor:tmpStr server:sender])	[sender addGuess:tmpPtr];
		[tmpStr free];

		tmpStr=[wordStr copy];			// typical german problem?
		[tmpStr replaceEveryOccurrenceOf:"sst" with:"t"];
		if(tmpPtr=[self suggsetionStrFor:tmpStr server:sender])	[sender addGuess:tmpPtr];
		[tmpStr free];

		tmpStr=[wordStr copy];			// typical german problem?
		[tmpStr replaceEveryOccurrenceOf:"sch" with:"ch"];
		if(tmpPtr=[self suggsetionStrFor:tmpStr server:sender])	[sender addGuess:tmpPtr];
		[tmpStr free];

		tmpStr=[wordStr copy];tmpSPtr=(char*)[tmpStr stringValue];
		for(i=0;i< [wordStr length];i++)	// first lets check if a wrong char was hit
		{	char oc=tmpSPtr[i],c=oc,sc;
			BOOL	wasUpper= NXIsUpper(c);
			int index=MIN(MAX(NXToLower(c)-NXToLower('a'),0),
						 (sizeof(simClusters)/sizeof(simClusters[0]))-1);
			const char *surrogates=simClusters[index];
#ifdef DEBUG
			fprintf(stderr,"%s\n",surrogates);
#endif
			while((sc=*surrogates++))
			{	tmpSPtr[i]=wasUpper? NXToUpper(sc):sc;
				if(tmpPtr=[self suggsetionStrFor:tmpStr server:sender])
				{	[sender addGuess:tmpPtr];
					if([wordStr length]> 4) break;	// speedheuristik
				}
			} tmpSPtr[i]=oc;
		} [tmpStr free];
	} [wordStr free];
}
@end